//
// Simple torus class
//

#include	"Vector3D.h"
#include	"Vector2D.h"
#include	"VertexArray.h"

#ifndef	__TORUS__
#define	__TORUS__

struct	Vertex
{
	Vector3D	pos;						// position of vertex
	Vector2D	tex;						// texture coordinates
	Vector3D	n;							// unit normal
};

struct	Face								// triangular face
{
	int	index [3];							// indices to Vertex array
};

class	Torus
{
	VertexArray    * vao;
	int		 numRings;
	int		 numSides;
	int		 numVertices;
	int		 numFaces;
	Vertex * vertices;
	Face   * faces;
	unsigned vertexId;						// id of vertex VBO
	unsigned indexId;
						// id of index VBO

public:
	Torus  ( float r1, float r2, int rings, int sides );
	~Torus ();

	void	setupBuffers ();				// create VBO's
	void	draw         ();				// do the drawing using VBO's
};

#endif
