//
// Vertex Array Object wrapper
// Author: Alexey Boreskov, <steps3d@gmail.com>, <steps3d@narod.ru>
//

#ifndef	__VERTEX_ARRAY_OBJECT__
#define	__VERTEX_ARRAY_OBJECT__

#include	"libExt.h"

class	VertexArray
{
	GLuint	id;
	
public:
	VertexArray ()
	{
		glGenVertexArrays ( 1, &id );
	}
	
	~VertexArray ()
	{
		glDeleteVertexArrays ( 1, &id );
	}
	
	bool	isOk () const
	{
		return glIsVertexArray ( id );
	}
	
	void	bind ()
	{
		glBindVertexArray ( id );
	}
	
	void	unbind ()
	{
		glBindVertexArray ( id );
	}
};

#endif
